//+------------------------------------------------------------------+
//|                                                          MMR.mq4 |
//|                                  Based on a strategy by cmillion |
//|             EMA5+LWMA85 crossover with MACD and RSI confirmation |
//+------------------------------------------------------------------+
#property copyright "Copyright @ 2011, downspin"
#property link      "mg@downspin.de"


#property indicator_separate_window
#property indicator_buffers    3
#property indicator_color1     DodgerBlue
#property indicator_color2     Green
#property indicator_color3     Red
#property indicator_width2     5
#property indicator_width3     5
#property indicator_level1     0
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern string TimeFrame                = "current time frame"; // time frame to use
extern int    mac_fast_ma              = 12;
extern int    mac_slow_ma              = 26;
extern int    mac_signal               = 9;
extern int    rsi_period               = 14;
extern int    ema_period               = 5;
extern int    lwma_period              = 85;
extern bool   alertsOn                 = false;
extern bool   alertsOnCurrent          = true;
extern bool   alertsMessage            = true;
extern bool   alertsSound              = false;
extern bool   alertsNotify             = false;
extern bool   alertsEmail              = false;
extern string soundFile                = "alert2.wav";
extern bool   ShowArrows               = true;
extern string arrowsIdentifier         = "mmr Arrows1";
extern double arrowsUpperGap           = 1.0;
extern double arrowsLowerGap           = 1.0;
extern bool   arrowsOnHisto            = true;
extern color  arrowsUpColor            = LimeGreen;
extern color  arrowsDnColor            = Red;
extern int    arrowsUpCode             = 241;
extern int    arrowsDnCode             = 242;
extern bool   arrowsOnZeroCross        = true;
extern color  arrowsOnZeroCrossUpColor = Green;
extern color  arrowsOnZeroCrossDnColor = PaleVioletRed;
extern int    arrowsOnZeroCrossUpCode  = 233;
extern int    arrowsOnZeroCrossDnCode  = 234;

//
//
//
//
//

double long1[];
double short1[];
double val[];
double trend[];
double atrend[];
double cross[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//
//
//
//
//

int init()
{
  IndicatorBuffers(6);
  SetIndexBuffer(0,val);  
  SetIndexBuffer(1,long1); SetIndexStyle(1,DRAW_HISTOGRAM); 
  SetIndexBuffer(2,short1);SetIndexStyle(2,DRAW_HISTOGRAM); 
  SetIndexBuffer(3,trend);
  SetIndexBuffer(4,atrend);
  SetIndexBuffer(5,cross);
  
  timeFrame         = stringToTimeFrame(TimeFrame);
  indicatorFileName = WindowExpertName();
  returnBars        = TimeFrame == "returnBars"; if (returnBars) return(0);
  
  IndicatorShortName(timeFrameToString(timeFrame)+" mmr");
  return(0);
}
int deinit()
{
   deleteArrows();
   
return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if (counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-2);
         if (returnBars) { val[0] = limit+1; return(0); }
         if (timeFrame!=Period())
         {
            limit = (int)MathMin(MathMax(limit,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()),Bars-2);
            for(int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);  
                  val[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",mac_fast_ma,mac_slow_ma,mac_signal,rsi_period,ema_period,lwma_period,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsOnHisto,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsOnZeroCross,arrowsOnZeroCrossUpColor,arrowsOnZeroCrossDnColor,arrowsOnZeroCrossUpCode,arrowsOnZeroCrossDnCode,0,y); 
                  long1[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",mac_fast_ma,mac_slow_ma,mac_signal,rsi_period,ema_period,lwma_period,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsOnHisto,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsOnZeroCross,arrowsOnZeroCrossUpColor,arrowsOnZeroCrossDnColor,arrowsOnZeroCrossUpCode,arrowsOnZeroCrossDnCode,1,y); 
                  short1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",mac_fast_ma,mac_slow_ma,mac_signal,rsi_period,ema_period,lwma_period,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsOnHisto,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsOnZeroCross,arrowsOnZeroCrossUpColor,arrowsOnZeroCrossDnColor,arrowsOnZeroCrossUpCode,arrowsOnZeroCrossDnCode,2,y); 
                 
            } 
         return(0);
         }
       
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--) 
   {
     double ema  =  iMA(NULL,0,ema_period, 0,1,0,i);
     double lwma =  iMA(NULL,0,lwma_period,0,3,0,i);
     double rsi  =  iRSI(NULL,0,rsi_period,0,i);
     double mac  =  iMACD(NULL,0,mac_fast_ma,mac_slow_ma,mac_signal,0,0,i);
            mac  *= 3000;
            rsi  -= 50;
            val[i] = (ema-lwma)/(Point*10)+mac+rsi;
            long1[i]  = EMPTY_VALUE;
            short1[i] = EMPTY_VALUE;
            trend[i]  = 0;
            atrend[i] = atrend[i+1];
            cross[i]  = cross[i+1];
            if (val[i]>0) cross[i] = 1;
            if (val[i]<0) cross[i] =-1;
            if((ema>lwma)&&(rsi>10) &&(mac>0)) { trend[i] = 1; atrend[i] = 1; }
            if((ema<lwma)&&(rsi<-10)&&(mac<0)) { trend[i] =-1; atrend[i] =-1; }
            if (trend[i] == 1) long1[i] = val[i]-10;
            if (trend[i] ==-1) short1[i]= val[i]+10;  
            
            //
           //
           //
           //
           //
     
           if (ShowArrows)
           {
              ObjectDelete(arrowsIdentifier+":1:"+Time[i]);
              ObjectDelete(arrowsIdentifier+":2:"+Time[i]);
              string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
              if (arrowsOnHisto && atrend[i] != atrend[i+1])
              {
                if (atrend[i] == 1) drawArrow("1",0.5,i,arrowsUpColor,arrowsUpCode,false);
                if (atrend[i] ==-1) drawArrow("1",0.5,i,arrowsDnColor,arrowsDnCode, true);
              } 
              if (arrowsOnZeroCross && cross[i] != cross[i+1])
              {
                if (cross[i] == 1) drawArrow("2",1,i,arrowsOnZeroCrossUpColor,arrowsOnZeroCrossUpCode,false);
                if (cross[i] ==-1) drawArrow("2",1,i,arrowsOnZeroCrossDnColor,arrowsOnZeroCrossDnCode, true);
              }                              
          }
   }
   
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (atrend[whichBar] != atrend[whichBar+1])
      if (atrend[whichBar] == 1)
            doAlert("Buy");
      else  doAlert("Sell");       
   }       
return(0);
}
   
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," mmr ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," mmr "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

void drawArrow(string nameAdd, double gapMul, int i,color theColor,int theCode,bool up)
{
      string name = arrowsIdentifier+":"+nameAdd+":"+Time[i];
      double gap  = iATR(NULL,0,20,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}



